<!-- index.html -->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0"> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjs/12.1.0/math.js" integrity="sha512-bJoAPYQ2bOZCtRLkShanIf6IMJAs+8oAmdq5Qjra47q/2ggFXhQeDycgJciFdatpPmS833KvRE7wU/gLqdxz8Q==" crossorigin="anonumous" referrerpolicy="no-referrer"></script>
    <title>Randomness Simulation</title>
    <link rel="stylesheet" href="./styles.css">
    <style>
        .slider-container {
            display: flex;
            justify-content: space-around;
            margin-top: 20px;
        }

        .slider-label {
            margin-right: 10px;
        }

        .bar {
            height: 20px;
            width: 100%;
            background-color: rgb(11, 138, 224);
        }

        .parameter-box-container {
            display: flex;
            justify-content: space-around;
            margin-top: 10px;
            align-items: center;
        }

        .parameter-box {
            display: flex;
            flex-direction: column;
            align-items: center;
        }

        .parameter-label {
            margin-bottom: 1px;
            align-items: center;
        }

        .parameter-input {
            width: 50px;
            text-align: center;
            margin-bottom: 2px;
        }
    </style>
</head>
<body>
    <div class="slider-container">
        <label class="slider-label">Number of Systems (M): <span id="systemValue">2</span></label>
        <input type="range" id="systemSlider" min="2" max="100" value="2">
        <br>
        <label class="slider-label">Number of Subintervals (N): <span id="attackValue">252</span></label>
        <input type="range" id="attackSlider" min="10" max="1000" value="252">
        <br>
        <label class="slider-label">Stochastic Process:</label>
        <select id="stochasticProcessValue">
            <option value="0">------Please choose stochastic Process------</option>
            <option value="1">Arithmetic Brownian Motion</option>
            <option value="2">Geometric Brownian Motion (Black–Scholes)</option>
            <option value="3">Ornstein–Uhlenbeck (mean-reverting)</option>
            <option value="4">Vasicek</option>
            <option value="5">Hull–White</option>
            <option value="6">Cox–Ingersoll–Ross</option>
            <option value="7">Black–Karasinski</option>
            <option value="8">Heston</option>
            <option value="9">Chen</option>
            <option value="13">Costum...</option>
        </select>
    </div>

    <div class="parameter-box-container">
        <div id="initialBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">Initial Value:</label>
            <input type="number" id="initialValue" class="parameter-input" value="10" step="0.1">
        </div>
        
        <div id="muBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">mu (μ):</label>
            <input type="number" id="muValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="sigmaBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">sigma (σ):</label>
            <input type="number" id="sigmaValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="thetaBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">theta (θ):</label>
            <input type="number" id="thetaValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="kappaBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">kappa (κ):</label>
            <input type="number" id="kappaValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="phiBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">phi (φ):</label>
            <input type="number" id="phiValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="nuBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">nu (ν):</label>
            <input type="number" id="nuValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="xiBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">xi (ξ):</label>
            <input type="number" id="xiValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="rhoBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">rho (ρ):</label>
            <input type="number" id="rhoValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="alphaBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">alpha (α):</label>
            <input type="number" id="alphaValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="betaBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">beta (β):</label>
            <input type="number" id="betaValue" class="parameter-input" value="1" step="0.1">
        </div>

        <div id="zetaBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">zeta (ζ):</label>
            <input type="number" id="zetaValue" class="parameter-input" value="1" step="0.1">
        </div>
        <div id="etaBox" style="display: none;" class="parameter-box">
            <label class="parameter-label">eta (η):</label>
            <input type="number" id="etaValue" class="parameter-input" value="1" step="0.1">
        </div>
        <div id="equationBox" style="display: none; " class="parameter-box">
            <label class="parameter-label" style="vertical-align: middle; text-align: center;">SDE:</label>
            <textarea id="equationValue"  class="parameter-input" rows="3" cols="64" style="vertical-align: middle; height:auto; width:auto; resize:none; text-align: right;" readonly></textarea>
        </div>
    </div>

    <div class="bar"></div>

    <canvas id="myCanvas" width="1920" height="1040"></canvas>

    <script type="module">
        import { updateChart } from './script.mjs';

        const systemSlider = document.getElementById('systemSlider');
        const attackSlider = document.getElementById('attackSlider');
        const stochasticProcessValue = document.getElementById('stochasticProcessValue');
        const initialValue = document.getElementById('initialValue');
        const initialBox = document.getElementById('initialBox');
        const muValue = document.getElementById('muValue');
        const muBox = document.getElementById('muBox');
        const sigmaValue = document.getElementById('sigmaValue');
        const sigmaBox = document.getElementById('sigmaBox');
        const thetaValue = document.getElementById('thetaValue');
        const thetaBox = document.getElementById('thetaBox');
        const kappaValue = document.getElementById('kappaValue');
        const kappaBox = document.getElementById('kappaBox');
        const phiValue = document.getElementById('phiValue');
        const phiBox = document.getElementById('phiBox');
        const nuValue = document.getElementById('nuValue');
        const nuBox = document.getElementById('nuBox');
        const xiValue = document.getElementById('xiValue');
        const xiBox = document.getElementById('xiBox');
        const rhoValue = document.getElementById('rhoValue');
        const rhoBox = document.getElementById('rhoBox');
        const alphaValue = document.getElementById('alphaValue');
        const alphaBox = document.getElementById('alphaBox');
        const betaValue = document.getElementById('betaValue');
        const betaBox = document.getElementById('betaBox');
        const zetaValue = document.getElementById('zetaValue');
        const zetaBox = document.getElementById('zetaBox');
        const etaValue = document.getElementById('etaValue');
        const etaBox = document.getElementById('etaBox');
        const equationBox = document.getElementById('equationBox');
        const equationValue = document.getElementById('equationValue');
        
        systemSlider.addEventListener('input', () => {
            systemValue.textContent = systemSlider.value;
            updateChart();
        });

        attackSlider.addEventListener('input' , () => {
            attackValue.textContent = attackSlider.value;
            updateChart();
        });

        stochasticProcessValue.addEventListener('change', () => {
            const selectedValue = parseInt(stochasticProcessValue.value, 10);
            console.log('Selected Stochastic Process:', selectedValue);
            
            // Call a function to show/hide relevant parameter inputs
            updateParameterInputs(selectedValue);
            displayStochasticProcessEquation(selectedValue);
            
            updateChart();
        });

        // Function to show/hide relevant parameter inputs based on the selected stochastic process
        function updateParameterInputs(selectedValue) {
            // List of parameter input elements
            const parameterInputs = [
                initialBox, muBox, sigmaBox, thetaBox, kappaBox,
                phiBox, nuBox, xiBox, rhoBox, alphaBox,
                betaBox, zetaBox, etaBox
            ];

            // Show all parameter inputs
            parameterInputs.forEach(input => input.style.display = 'block');

            // Based on the selected stochastic process, hide irrelevant inputs
            switch (selectedValue) {
                case 0: // No option selected
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    initialBox.style.display = 'none';
                    muBox.style.display = 'none';
                    sigmaBox.style.display = 'none';
                    thetaBox.style.display = 'none';
                    kappaBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 1: // Arithmetic Brownian Motion
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    thetaBox.style.display = 'none';
                    kappaBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 2: // Geometric Brownian Motion
                    thetaBox.style.display = 'none';
                    kappaBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 3: // Ornstein-Uhlenbeck   
                    kappaBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 4: // Vasicek  
                    muBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 5: // Hull-White
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    muBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 6: // CIS
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    muBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 7: // Black Karasinski
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    muBox.style.display = 'none'; 
                    kappaBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 8: // Heston
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    sigmaBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 9: // Chen
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    phiBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    equationValue.setAttribute('readonly', 'readonly');
                    break;
                case 13: // Costum
                    // Hide unnecessary inputs for Arithmetic Brownian Motion
                    muBox.style.display = 'none';
                    sigmaBox.style.display = 'none';
                    thetaBox.style.display = 'none';
                    kappaBox.style.display = 'none';
                    phiBox.style.display = 'none';
                    nuBox.style.display = 'none';
                    xiBox.style.display = 'none';
                    rhoBox.style.display = 'none';
                    alphaBox.style.display = 'none';
                    betaBox.style.display = 'none';
                    zetaBox.style.display = 'none';
                    etaBox.style.display = 'none';
                    systemSlider.value = 10;
                    systemValue.textContent = systemSlider.value;
                    attackSlider.value = 10;
                    attackValue.textContent = attackSlider.value;
                    equationValue.removeAttribute('readonly');
                    break;
            }
        }

        function displayStochasticProcessEquation(selectedValue) {
        // Map of stochastic process equations
            const equations = {
                1: 'dS = mu * dt + sigma * dW',
                2: 'dS = mu * S * dt + sigma * S * dW',
                3: 'dS = theta * (mu - S) * dt + sigma * dW',
                4: 'dS = kappa * (theta - S) * dt + sigma * dW',
                5: 'dS = (theta - kappa * S) * dt + sigma * dW',
                6: 'dS = kappa * (theta - S) * dt + sigma * Math.sqrt(S) * dW',
                7: 'dS = (theta - phi * Math.log(S)) * dt + sigma * Math.sqrt(S) * dW',
                8: 'dS = mu * S * dt + Math.sqrt(nu) * S * dW1\n dnu = kappa * (theta - nu) * dt + xi * Math.sqrt(nu) * dW2\ndW2 = rho * dW1 + Math.sqrt(1 - rho * rho) * Math.sqrt(dt) * gaussianRandom()',
                9: 'dS = kappa * (theta - S) * dt + Math.sqrt(S * sigma) * dW1\ndtheta = nu * (zeta - theta) * dt + alpha * Math.sqrt(theta) * dW2\ndsigma = mu * (beta - sigma) * dt + eta * Math.sqrt(sigma) * dW3',
                13: 'dS = (1.5 * S) * dt + (2 * S) * dW'
                // Add equations for other stochastic processes
            };

            // Display the equation for the selected stochastic process
            equationValue.value = equations[selectedValue];
            equationBox.style.display = 'block';
        }

        initialValue.addEventListener('input', updateChart);
        muValue.addEventListener('input', updateChart);
        sigmaValue.addEventListener('input', updateChart);
        thetaValue.addEventListener('input', updateChart);
        kappaValue.addEventListener('input', updateChart);
        phiValue.addEventListener('input', updateChart);
        nuValue.addEventListener('input', updateChart);
        xiValue.addEventListener('input', updateChart);
        rhoValue.addEventListener('input', updateChart);
        alphaValue.addEventListener('input', updateChart);
        betaValue.addEventListener('input', updateChart);
        zetaValue.addEventListener('input', updateChart);
        etaValue.addEventListener('input', updateChart);
        equationValue.addEventListener('input', updateChart);
    </script>

    <script type="module" src="./script.mjs"></script>
    <script type="module" src="./calculation.mjs"></script>
</body> 
</html>
